var topic = "<!DOCTYPE html>\n\
\n\
<!-- saved from url=(0024)http://docs.autodesk.com -->\n\
<html>\n\
   <head>\n\
<link href=\"../style/prettify.css\" type=\"text/css\" rel=\"stylesheet\">\n\
<script type=\"text/javascript\" src=\"../scripts/prettify.js\"></script><script src=\"../scripts/lib/jquery-1.11.1.min.js\" type=\"text/javascript\"></script>\n\
      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n\
      <meta name=\"product\" content=\"MAYAUL\">\n\
      <meta name=\"release\" content=\"2018\">\n\
      <meta name=\"book\" content=\"Developer\">\n\
      <meta name=\"created\" content=\"2017-02-19\">\n\
      <meta name=\"topicid\" content=\"GUID-927AD891-F772-4FF2-B8FA-B711098E659B\">\n\
      <meta name=\"topic-type\" content=\"concept\">\n\
      <title>ロック</title></head>\n\
   <body height=\"100%\"><div class=\"body_content\" id=\"body-content\"><script language=\"javascript\">var index = \'index.html\';</script><script>$(document).ready(function() { yepnope.injectJs(\"./scripts/ac_common.js\"); });</script><script>$(document).ready(function() { yepnope.injectJs(\"./scripts/multireflink.js\"); });</script><script>$(document).ready(function () { prettyPrint(); } );</script><script></script><script></script><div id=\"reflinkdiv\"></div>\n\
      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-927AD891-F772-4FF2-B8FA-B711098E659B\"></a><div class=\"head\">\n\
            <h1>ロック</h1>\n\
         </div>\n\
         <p><a name=\"WS73099CC142F487557109353211EEADCAF73-710D\"></a>ロックは、シングル スレッドのみがいつでもコードをトラバースできるように、コードの領域を定義するオペレータです。また、ロックはミューテックス(相互排除)とも呼ばれますが、この言葉は\n\
            OS によっては若干意味が異なる場合があります。代表的な例として、さまざまなスレッドからの 1 つのグローバル変数に対する複数同時書き込みの保護が挙げられます。たとえば、このコードが複数のスレッドからコールされる場合、次のようになります。\n\
         </p>\n\
         <div class=\"codeBlock\"><pre class=\"prettyprint\">\n\
static int val=0;\n\
LOCK;\n\
val++;\n\
UNLOCK;\n\
</pre></div>\n\
         <p><a name=\"WS73099CC142F487557109353211EEADCAF73-710C\"></a>ロックが適切でなかった場合、2 つのスレッドが同時に val の修正を試行でき、双方ともは読み取り、更新、書き込みを個別のステージで行うため、正しい結果が出ません。これは競合状態と呼ばれます。これについては、後半で詳細に説明します。\n\
         </p>\n\
         <p><a name=\"WS73099CC142F487557109353211EEADCAF73-710B\"></a>ロックは再帰的であるため、同じスレッドが同じロックを複数回取得できます。ただし、これは一般的には危険性の高いコーディング手法とされます。ロックと同じ回数ロックを解除できなかった場合、ハングが発生し、ロックが解放されなくなってしまうためです。\n\
         </p>\n\
         <p><a name=\"WS73099CC142F487557109353211EEADCAF73-710A\"></a>競合状態を回避してロックを適切に管理することは、スレッド化の中で最も困難な作業の 1 つです。\n\
         </p>\n\
         <div class=\"section\"><a name=\"WS73099CC142F487557109353211EEADCAF73-7109\"></a> \n\
            <h2><a name=\"GUID-B476CC7C-DBEC-4F21-8C47-CB6EB74BD43A\"></a>アトミック操作\n\
            </h2> \n\
            <p><a name=\"WS73099CC142F487557109353211EEADCAF73-7108\"></a>現在最新のプロセッサは、変数に対して所定のアトミック操作を実行できます。つまり、他のスレッドの実行から見ると、操作は 1 回の手順で完了するように見えます。結果として、このようなアトミック操作では修正操作中に別スレッドから値を読み取ることができないため、競合状態が生じることはなく、ロックも不要になります。オペレーティング\n\
               システムによっては、このようなアトミック操作をハードウェアで直接コールできる低レベルの機能が用意されています。この操作は、ユーザ ロックの適用よりもはるかに高速であるため、できれば常時使用することをお勧めします。\n\
            </p> \n\
         </div>\n\
         <div class=\"section\"><a name=\"WS73099CC142F487557109353211EEADCAF73-7107\"></a> \n\
            <h2><a name=\"GUID-2758058E-E3E5-4F88-9EB5-3DB081BA75D2\"></a>セマフォとシグナル\n\
            </h2> \n\
            <p><a name=\"WS73099CC142F487557109353211EEADCAF73-7106\"></a>セマフォは、ミューテックス ロックを一般化したものです。単純な boolean 状態のミューテックス ロックとは異なり、セマフォには内部カウンタがあります。内部カウンタは、スレッドからセマフォに対してロックされたリソースへのアクセスが要求されるたびにデクリメントし、スレッドがリソースを解放するたびにインクリメントします。カウンタがゼロになると、保持されているスレッドのいずれかのリソースが解放されるまで、リソースの獲得を試行する他のスレッドは遮断されます。したがって、セマフォに初期値として\n\
               5 を指定した場合、同時にリソースにアクセスできるスレッドは最大で 5 つまでです。\n\
            </p> \n\
         </div>\n\
         <div class=\"section\"><a name=\"WS73099CC142F487557109353211EEADCAF73-7105\"></a> \n\
            <h2><a name=\"GUID-62865C84-F1CA-45C4-B1AB-AEE21953AD50\"></a> pthread の OSX プラットフォーム固有の問題\n\
            </h2> \n\
            <p><a name=\"WS73099CC142F487557109353211EEADCAF73-7104\"></a>OSX pthread の実装は POSIX 標準に準拠しますが、Linux で使用可能なすべての pthread と関連機能が含まれているわけではありません。<span class=\"char_link\"><a href=\"#!/url=./files/GUID-EE052898-C59C-438A-9A77-798F5BEB7A77.htm\">Mac OS X プラットフォーム固有の pthread の課題</a></span>に詳細情報が記載されています。これは OS X で直接 pthread を使用して作業するすべてのユーザにとって重要となります。 \n\
            </p> \n\
         </div>\n\
         <div class=\"section\"><a name=\"WS73099CC142F487557109353211EEADCAF73-7103\"></a> \n\
            <h2><a name=\"GUID-7D1CA075-B9CC-48AD-919A-FD892E3134FE\"></a>ネイティブ スレッドの使用\n\
            </h2> \n\
            <p><a name=\"WS73099CC142F487557109353211EEADCAF73-7102\"></a>このようなスレッド化の基礎は、シングル プラットフォームで低レベルで処理する場合に役立ちます。実装が異なるため、クロスプラットフォーム アプリケーションで使用する場合は複雑になります。後半で説明する一部の高レベルのスレッド化実装と比較すると、多数の処理が必要です。ただし、優先順位やアフィニティなどの操作を含むスレッドの動作を根本的に制御する必要がある場合、ネイティブ\n\
               スレッドを選択するのが最適です。\n\
            </p> \n\
         </div>\n\
         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">このトピックについてのコメントをお送りください</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/deed.ja\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"images/ccLink.png\"></a>&nbsp;<em>特に明記されている場合以外は、この作業は、<a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/deed.ja\" target=\"_blank\">Creative Commons 表示 - 非営利 - 継承 3.0 非移植ライセンス</a> のもと認可を受けています。 <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> (英語版) を参照してください。</em></p><br></div>\n\
   </div></body>\n\
</html>";