var topic = "<!DOCTYPE html>\n\
\n\
<!-- saved from url=(0024)http://docs.autodesk.com -->\n\
<html>\n\
   <head>\n\
<link href=\"../style/prettify.css\" type=\"text/css\" rel=\"stylesheet\">\n\
<script type=\"text/javascript\" src=\"../scripts/prettify.js\"></script><script src=\"../scripts/lib/jquery-1.11.1.min.js\" type=\"text/javascript\"></script>\n\
      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n\
      <meta name=\"product\" content=\"MAYAUL\">\n\
      <meta name=\"release\" content=\"2018\">\n\
      <meta name=\"book\" content=\"Developer\">\n\
      <meta name=\"created\" content=\"2017-02-19\">\n\
      <meta name=\"topicid\" content=\"GUID-A343C962-AEE1-4113-9DEC-1A88CF818AE9\">\n\
      <meta name=\"topic-type\" content=\"concept\">\n\
      <title>コマンド引数とフラグ</title></head>\n\
   <body height=\"100%\"><div class=\"body_content\" id=\"body-content\"><script language=\"javascript\">var index = \'index.html\';</script><script>$(document).ready(function() { yepnope.injectJs(\"./scripts/ac_common.js\"); });</script><script>$(document).ready(function() { yepnope.injectJs(\"./scripts/multireflink.js\"); });</script><script>$(document).ready(function () { prettyPrint(); } );</script><script></script><script></script><div id=\"reflinkdiv\"></div>\n\
      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-A343C962-AEE1-4113-9DEC-1A88CF818AE9\"></a><div class=\"head\">\n\
            <h1>コマンド引数とフラグ</h1>\n\
         </div>\n\
         <p><a name=\"GUID-D3B5987A-DF41-44B3-896E-45F63B751FA0\"></a>このトピックでは、コマンドの引数とフラグの使用について説明します。 \n\
         </p>\n\
         <div class=\"section\"><a name=\"SECTION_D67047E8B8034879B7B6107552D29782\"></a> \n\
            <h2><a name=\"GUID-B99215E9-0E57-40DE-8523-5538F8DA0EF3\"></a>「フラグ」と「コマンド引数」\n\
            </h2> \n\
            <p><a name=\"GUID-A9C044FA-4F0D-49C6-8640-E782B284E3BE\"></a> Maya API マニュアルのコンテキストでは、「フラグ」と「コマンド引数」という用語が特定の意味を持っています。これらの用語の意味を次に説明します。 \n\
            </p> <a name=\"UL_D3E94AE4D5584E2A927299B8DEE0236E\"></a><ul>\n\
               <li><em class=\"strong\">「フラグ」</em>: フラグは、コマンドの通常の動作のオプションです。各フラグには、ロング ネームとショート ネームがあります。MEL コマンドで使用する場合は、フラグの前にハイフン(「<span class=\"code\" translate=\"no\">-</span>」)が付加されます。Python の場合、フラグは、ハイフンのない名前付き関数引数として表示されます。次の例では、「<span class=\"code\" translate=\"no\">sx</span>」、「<span class=\"code\" translate=\"no\">sy</span>」、「<span class=\"code\" translate=\"no\">sz</span>」、および「<span class=\"code\" translate=\"no\">h</span>」フラグが、各軸のサブディビジョンの数と <span class=\"code\" translate=\"no\">cmds.polyCube()</span> で作成したキューブの高さを指定しています。 \n\
                  <div class=\"codeBlock\"><pre class=\"prettyprint\">import maya.cmds as cmds\n\
cmds.polyCube( sx=10, sy=15, sz=5, h=20 )</pre></div> \n\
                  <div><a name=\"GUID-394AB83F-ACAF-4195-8309-1937310EDFB7\"></a><div class=\"note-note\"><span class=\"label label-target-language\">注:</span>また、単一のフラグは、値のタプル(たとえば、カラーの<span class=\"code\" translate=\"no\">(R、G、B)</span>値)を受け入れることができます。タプルの各項目は、フラグ パラメータと呼ばれます。<em class=\"mild\"></em><span class=\"char_link\"><a href=\"#!/url=./files/GUID-A343C962-AEE1-4113-9DEC-1A88CF818AE9.htm#SECTION_2C3E671A8E204226900E11E4FC8B2482\">以下の</a></span>、複数のフラグ パラメータの解析で詳しく説明します。 \n\
                     </div>\n\
                  </div> \n\
               </li>\n\
               <li><em class=\"strong\">「コマンド引数」</em>: コマンド引数には、関連付けられた名前がありません。MEL コマンドでコマンド引数を使用する場合は、呼び出しの最後に表示されます。対照的に、Python の言語設計のため、コマンド引数は、<span class=\"code\" translate=\"no\">maya.cmds</span> 関数呼び出しの最初に表示されます。以下の例は、コマンド引数とフラグの違いを示しています。<em class=\"mild\"></em><em class=\"mild\"></em> \n\
                  <div class=\"codeBlock\"><pre class=\"prettyprint\">import maya.cmds as cmds\n\
cmds.group( \'circle1\', \'sphere1\', n=\'group1\' )</pre></div>ここで、<span class=\"code\" translate=\"no\">\'circle1\'</span> と <span class=\"code\" translate=\"no\">\'sphere1\'</span> は <span class=\"code\" translate=\"no\">cmds.group()</span> のコマンド引数です。これらは、オブションの「<span class=\"code\" translate=\"no\">n</span>」フラグの前に配置されます。このフラグを使用して、結果として生じるグループの名前を指定します。 \n\
               </li>\n\
            </ul> \n\
            <p><a name=\"GUID-BA94B37C-B520-414D-BF10-876C02B45018\"></a>現在選択されている Maya オブジェクトをコマンドの引数として使用することもできます。<em class=\"mild\"></em>この場合、コマンド引数とオブジェクトに互換性がなく、コマンドの構文定義で結合できません。<em class=\"mild\"></em><em class=\"mild\"></em>詳細については、<span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"MSyntax\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_syntax.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_syntax.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MSyntax</a></span> クラスのマニュアルを参照してください。 \n\
            </p> \n\
         </div>\n\
         <div class=\"section\"><a name=\"SECTION_604AA254DDD643D2AD0ECF792FC74E58\"></a> \n\
            <h2><a name=\"GUID-90DC2AAE-CF4A-46C5-849B-3436D76277A7\"></a>コマンド プラグインのサンプル: フラグを作成する\n\
            </h2> \n\
            <p><a name=\"GUID-6926A3E6-B048-4502-B41E-EA3D9CC14001\"></a>以下のプラグイン コードでは、渡されれたフラグに関連付けられている値を出力するコマンドを作成します。<span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"MSyntax\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_syntax.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_syntax.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MSyntax</a></span> および <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"MArgParser\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_arg_parser.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_arg_parser.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MArgParser</a></span> クラス マニュアルには、コマンドでフラグ、引数、選択したオブジェクトを使用する方法についての追加情報が含まれています。 \n\
            </p> <a name=\"SECTION_1DE6E95C9B3947B183E974AE8C0BCFAB\"></a><details class=\"section\">\n\
               <summary><a name=\"GUID-923D1CDA-9FB9-4461-9DCE-E98B395FCC6B\"></a><span class=\"collapsible-section-title\">Python API 2.0: </span></summary>\n\
               <div class=\"collapsible-section\">\n\
                  <div class=\"codeBlock\"><pre class=\"prettyprint\"># pySampleCommandFlag.py\n\
\n\
import sys\n\
\n\
import maya.api.OpenMaya as OpenMaya\n\
# ... additional imports here ...\n\
\n\
kPluginCmdName = \'myCommandWithFlag\'\n\
\n\
kShortFlagName = \'-mf\'\n\
kLongFlagName = \'-myFlag\'\n\
\n\
def maya_useNewAPI():\n\
	\"\"\"\n\
	The presence of this function tells Maya that the plugin produces, and\n\
	expects to be passed, objects created using the Maya Python API 2.0.\n\
	\"\"\"\n\
	pass\n\
	\n\
##########################################################\n\
# Plug-in \n\
##########################################################\n\
class MyCommandWithFlagClass( <a href=\"javascript:void(0)\" data-symbol=\"OpenMaya.MPxCommand\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_px_command.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">OpenMaya.MPxCommand</a> ):\n\
    \n\
    def __init__(self):\n\
        \'\'\' Constructor. \'\'\'\n\
        <a href=\"javascript:void(0)\" data-symbol=\"OpenMaya.MPxCommand.__init__\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_px_command.html#a0e33c57b86f794759092176b16cc0b44&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">OpenMaya.MPxCommand.__init__</a>(self)\n\
    \n\
    def doIt(self, args):\n\
        \'\'\' Command execution. \'\'\'\n\
        \n\
        # We recommend parsing your arguments first.\n\
        self.parseArguments( args )\n\
\n\
        # Remove the following \'pass\' keyword and replace it with the code you want to run. \n\
        pass\n\
    \n\
    def parseArguments(self, args):\n\
        \'\'\' \n\
        The presence of this function is not enforced,\n\
        but helps separate argument parsing code from other\n\
        command code. \n\
        \'\'\'\n\
        \n\
        # The following <a href=\"javascript:void(0)\" data-symbol=\"MArgParser\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_arg_parser.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_arg_parser.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MArgParser</a> object allows you to check if specific flags are set.\n\
        argData = <a href=\"javascript:void(0)\" data-symbol=\"OpenMaya.MArgParser\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_arg_parser.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">OpenMaya.MArgParser</a>( self.syntax(), args )\n\
        \n\
        if argData.isFlagSet( kShortFlagName ):\n\
                \n\
            # In this case, we print the passed flag\'s value as an integer.\n\
            # We use the \'0\' to index the flag\'s first and only parameter.\n\
            flagValue = argData.flagArgumentInt( kShortFlagName, 0 )\n\
            print kLongFlagName + \': \' + str( flagValue )\n\
            \n\
        \n\
        # ... If there are more flags, process them here ...\n\
\n\
##########################################################\n\
# Plug-in initialization.\n\
##########################################################\n\
def cmdCreator():\n\
    \'\'\' Create an instance of our command. \'\'\'\n\
    return MyCommandWithFlagClass() \n\
\n\
def syntaxCreator():\n\
    \'\'\' Defines the argument and flag syntax for this command. \'\'\'\n\
    syntax = <a href=\"javascript:void(0)\" data-symbol=\"OpenMaya.MSyntax\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_syntax.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">OpenMaya.MSyntax</a>()\n\
    \n\
    # In this example, our flag will be expecting a numeric value, denoted by OpenMaya.MSyntax.kDouble. \n\
    syntax.addFlag( kShortFlagName, kLongFlagName, <a href=\"javascript:void(0)\" data-symbol=\"OpenMaya.MSyntax.kDouble\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_syntax.html#a9b557d97e6ea6e2e7a3757b810a4c627&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">OpenMaya.MSyntax.kDouble</a> )\n\
    \n\
    # ... Add more flags here ...\n\
        \n\
    return syntax\n\
    \n\
def initializePlugin( mobject ):\n\
    \'\'\' Initialize the plug-in when Maya loads it. \'\'\'\n\
    mplugin = <a href=\"javascript:void(0)\" data-symbol=\"OpenMaya.MFnPlugin\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_fn_plugin.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">OpenMaya.MFnPlugin</a>( mobject )\n\
    try:\n\
        mplugin.registerCommand( kPluginCmdName, cmdCreator, syntaxCreator )\n\
    except:\n\
        sys.stderr.write( \'Failed to register command: \' + kPluginCmdName )\n\
\n\
def uninitializePlugin( mobject ):\n\
    \'\'\' Uninitialize the plug-in when Maya un-loads it. \'\'\'\n\
    mplugin = <a href=\"javascript:void(0)\" data-symbol=\"OpenMaya.MFnPlugin\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_fn_plugin.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">OpenMaya.MFnPlugin</a>( mobject )\n\
    try:\n\
        mplugin.deregisterCommand( kPluginCmdName )\n\
    except:\n\
        sys.stderr.write( \'Failed to unregister command: \' + kPluginCmdName )\n\
\n\
##########################################################\n\
# Sample usage.\n\
##########################################################\n\
\'\'\' \n\
# Copy the following lines and run them in Maya\'s Python Script Editor:\n\
\n\
import maya.cmds as cmds\n\
cmds.loadPlugin( \'sampleCommandFlag.py\' )\n\
cmds.myCommandWithFlag( myFlag = 4 )\n\
\n\
\'\'\'</pre></div>\n\
               </div>\n\
            </details> <a name=\"SECTION_294D7BEA213D4DACAAAA647AAD82FC42\"></a><details class=\"section\">\n\
               <summary><a name=\"GUID-F1978485-1E68-439E-AF4E-E30B88C8ED05\"></a><span class=\"collapsible-section-title\">Python API 1.0: </span></summary>\n\
               <div class=\"collapsible-section\">\n\
                  <div class=\"codeBlock\"><pre class=\"prettyprint\"># sampleCommandFlag.py\n\
\n\
import sys\n\
import maya.OpenMayaMPx as OpenMayaMPx\n\
import maya.OpenMaya as OpenMaya\n\
# ... additional imports here ...\n\
\n\
kPluginCmdName = \'myCommandWithFlag\'\n\
\n\
kShortFlagName = \'-mf\'\n\
kLongFlagName = \'-myFlag\'\n\
\n\
##########################################################\n\
# Plug-in \n\
##########################################################\n\
class MyCommandWithFlagClass( OpenMayaMPx.MPxCommand ):\n\
    \n\
    def __init__(self):\n\
        \'\'\' Constructor. \'\'\'\n\
        OpenMayaMPx.MPxCommand.__init__(self)\n\
    \n\
    def doIt(self, args):\n\
        \'\'\' Command execution. \'\'\'\n\
        \n\
        # We recommend parsing your arguments first.\n\
        self.parseArguments( args )\n\
\n\
        # Remove the following \'pass\' keyword and replace it with the code you want to run. \n\
        pass\n\
    \n\
    def parseArguments(self, args):\n\
        \'\'\' \n\
        The presence of this function is not enforced,\n\
        but helps separate argument parsing code from other\n\
        command code. \n\
        \'\'\'\n\
        \n\
        # The following <a href=\"javascript:void(0)\" data-symbol=\"MArgParser\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_arg_parser.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_arg_parser.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MArgParser</a> object allows you to check if specific flags are set.\n\
        argData = <a href=\"javascript:void(0)\" data-symbol=\"OpenMaya.MArgParser\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_arg_parser.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">OpenMaya.MArgParser</a>( self.syntax(), args )\n\
        \n\
        if argData.isFlagSet( kShortFlagName ):\n\
                \n\
            # In this case, we print the passed flag\'s value as an integer.\n\
            # We use the \'0\' to index the flag\'s first and only parameter.\n\
            flagValue = argData.flagArgumentInt( kShortFlagName, 0 )\n\
            print kLongFlagName + \': \' + str( flagValue )\n\
            \n\
        \n\
        # ... If there are more flags, process them here ...\n\
\n\
##########################################################\n\
# Plug-in initialization.\n\
##########################################################\n\
def cmdCreator():\n\
    \'\'\' Create an instance of our command. \'\'\'\n\
    return OpenMayaMPx.asMPxPtr( MyCommandWithFlagClass() )\n\
\n\
def syntaxCreator():\n\
    \'\'\' Defines the argument and flag syntax for this command. \'\'\'\n\
    syntax = <a href=\"javascript:void(0)\" data-symbol=\"OpenMaya.MSyntax\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_syntax.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">OpenMaya.MSyntax</a>()\n\
    \n\
    # In this example, our flag will be expecting a numeric value, denoted by OpenMaya.MSyntax.kDouble. \n\
    syntax.addFlag( kShortFlagName, kLongFlagName, <a href=\"javascript:void(0)\" data-symbol=\"OpenMaya.MSyntax.kDouble\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_syntax.html#a9b557d97e6ea6e2e7a3757b810a4c627&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">OpenMaya.MSyntax.kDouble</a> )\n\
    \n\
    # ... Add more flags here ...\n\
        \n\
    return syntax\n\
    \n\
def initializePlugin( mobject ):\n\
    \'\'\' Initialize the plug-in when Maya loads it. \'\'\'\n\
    mplugin = OpenMayaMPx.MFnPlugin( mobject )\n\
    try:\n\
        mplugin.registerCommand( kPluginCmdName, cmdCreator, syntaxCreator )\n\
    except:\n\
        sys.stderr.write( \'Failed to register command: \' + kPluginCmdName )\n\
\n\
def uninitializePlugin( mobject ):\n\
    \'\'\' Uninitialize the plug-in when Maya un-loads it. \'\'\'\n\
    mplugin = OpenMayaMPx.MFnPlugin( mobject )\n\
    try:\n\
        mplugin.deregisterCommand( kPluginCmdName )\n\
    except:\n\
        sys.stderr.write( \'Failed to unregister command: \' + kPluginCmdName )\n\
\n\
##########################################################\n\
# Sample usage.\n\
##########################################################\n\
\'\'\' \n\
# Copy the following lines and run them in Maya\'s Python Script Editor:\n\
\n\
import maya.cmds as cmds\n\
cmds.loadPlugin( \'sampleCommandFlag.py\' )\n\
cmds.myCommandWithFlag( myFlag = 4 )\n\
\n\
\'\'\'</pre></div>\n\
               </div>\n\
            </details> \n\
            <div><a name=\"GUID-3A9760D7-8142-4C0B-ADE7-A7B4B5543228\"></a><div class=\"note-note\"><span class=\"label label-target-language\">注:</span>コマンド引数を使用する実用的な例については、「<span class=\"char_link\"><a href=\"#!/url=./files/GUID-6031DE26-93CE-445A-AED9-C27C659268E5.htm\">例: IK ジョイント チェーンを作成する</a></span>」を参照してください。 \n\
               </div>\n\
            </div> \n\
         </div>\n\
         <div class=\"section\"><a name=\"SECTION_732427F029954975A16120F79636242E\"></a> \n\
            <h2><a name=\"GUID-B0E024C5-2EFC-469F-BAFC-006A6AB442DB\"></a>Maya プラグイン エントリ/エグジット ポイント: 引数構文を登録する\n\
            </h2> \n\
            <p><a name=\"GUID-029D68D1-0BB1-451D-9CC6-FAB1171CAFD3\"></a>引数またはフラグを処理しないコマンドと比較すると、<span class=\"code\" translate=\"no\">initializePlugin()</span> エントリ ポイントは、コマンドの引数構文を含むように修正する必要があります。 \n\
            </p> \n\
            <div class=\"codeBlock\"><pre class=\"prettyprint\">mplugin.registerCommand( kPluginCmdName, cmdCreator, syntaxCreator )\n\
    </pre></div> \n\
            <p><a name=\"GUID-AE351CCB-6310-4D21-9A1C-D31CBB8BAD9B\"></a> 特に、<span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"MFnPlugin.registerCommand()\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_fn_plugin.html#a64fa4221b58a1bd2937e0bb93e50b3c8&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MFnPlugin.registerCommand()</a></span> への呼び出しに 3 番目のパラメータ <span class=\"code\" translate=\"no\">syntaxCreator</span> を含める必要があります。<span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"MFnPlugin.registerCommand()\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_fn_plugin.html#a64fa4221b58a1bd2937e0bb93e50b3c8&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MFnPlugin.registerCommand()</a></span> の関数パラメータを次に示します。 \n\
            </p> <a name=\"OL_13DD3816F9D544699FDF784741D38366\"></a><ol type=\"1\" start=\"1\">\n\
               <li><em class=\"strong\">コマンド名</em>: コマンド <span class=\"code\" translate=\"no\">\'myCommandWithFlag\'</span> の名前です。これにより、MEL または Python の <span class=\"code\" translate=\"no\">maya.cmds</span> モジュールを使用してコマンドを実行する方法が決定されます。 \n\
               </li>\n\
               <li><em class=\"strong\">コマンド作成関数リファレンス</em>: コマンド <span class=\"code\" translate=\"no\">cmdCreator</span> のインスタンスを作成する関数へのリファレンスです。 \n\
               </li>\n\
               <li> \n\
                  <p><a name=\"GUID-500ACE4F-A535-4C01-864C-ACE4723BE449\"></a><em class=\"strong\">構文作成関数</em>: <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"MSyntax\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_syntax.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_syntax.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MSyntax</a></span> オブジェクト <span class=\"code\" translate=\"no\">syntaxCreator</span> を返す関数へのリファレンスです。この返された <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"MSyntax\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_syntax.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_syntax.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MSyntax</a></span> オブジェクトは、各フラグの必要なタイプのほか、各フラグのロング ネームとショート ネームを定義します。フラグのショート ネーム(<span class=\"code\" translate=\"no\">kShortFlagName</span>)は、ハイフンが前に付加された 1 または 2 文字の文字列にする必要があります(<span class=\"code\" translate=\"no\">\'-mf\'</span>)。一般的に、フラグのロング ネーム(<span class=\"code\" translate=\"no\">kLongFlagName</span>)はより説明的であり、ハイフンを前に付加する必要があります(<span class=\"code\" translate=\"no\">\'-myFlag\'</span>)。 \n\
                  </p> \n\
                  <div class=\"codeBlock\"><pre class=\"prettyprint\">kShortFlagName = \'-mf\'\n\
kLongFlagName = \'-myFlag\'\n\
\n\
# ...\n\
\n\
def syntaxCreator():\n\
    \'\'\' Defines the argument and flag syntax for this command. \'\'\'\n\
    syntax = <a href=\"javascript:void(0)\" data-symbol=\"OpenMaya.MSyntax\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_syntax.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">OpenMaya.MSyntax</a>()\n\
    \n\
    # In this example, our flag will be expecting a numeric value, denoted by OpenMaya.MSyntax.kDouble. \n\
    syntax.addFlag( kShortFlagName, kLongFlagName, <a href=\"javascript:void(0)\" data-symbol=\"OpenMaya.MSyntax.kDouble\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_syntax.html#a9b557d97e6ea6e2e7a3757b810a4c627&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">OpenMaya.MSyntax.kDouble</a> )\n\
    \n\
    # ... Add more flags here ...\n\
        \n\
    return syntax</pre></div> \n\
                  <p><a name=\"GUID-169A8D77-3B8F-44E2-BD89-D72677943765\"></a> \n\
                     <div><a name=\"GUID-3BC9D170-7199-4406-99CC-7E3FB10455C7\"></a><div class=\"note-note\"><span class=\"label label-target-language\">注:</span>コマンド引数を追加するには、<span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"MSyntax.addArg()\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_syntax.html#ad9b8c499fe50944cb64d6e48d3fef504&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MSyntax.addArg()</a></span> 関数を使用します。<em class=\"mild\"></em>詳細については、<span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"MSyntax\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_syntax.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_syntax.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MSyntax</a></span> クラスのマニュアルを参照してください。 \n\
                        </div>\n\
                     </div> \n\
                  </p> \n\
               </li>\n\
            </ol> \n\
         </div>\n\
         <div class=\"section\"><a name=\"SECTION_04F20935BBBD4FCBA902799123737AFE\"></a> \n\
            <h2><a name=\"GUID-C8AE68FB-3824-43EA-897F-91870838F244\"></a>コマンドの動作: フラグを解析する\n\
            </h2> \n\
            <p><a name=\"GUID-B493111A-3CA7-43DC-A183-A688D4C3AA2B\"></a>コマンドの <span class=\"code\" translate=\"no\">doIt()</span> メソッドでは、渡された引数とフラグを解析する専用のコードが必要です。<span class=\"code\" translate=\"no\">parseArguments()</span> で、<span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"MSyntax\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_syntax.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_syntax.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MSyntax</a></span> オブジェクト(<span class=\"code\" translate=\"no\">self.syntax()</span> から取得した)を使用して <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"MArgParser\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_arg_parser.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_arg_parser.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MArgParser</a></span> オブジェクトと <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"MArgList\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_arg_list.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_arg_list.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MArgList</a></span> オブジェクト(<span class=\"code\" translate=\"no\">args</span>)をインスタンス化します。<span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"MArgParser.isFlagSet()\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_arg_parser.html#a2c282ba91b6e3de0539aa6c1615a1fae&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MArgParser.isFlagSet()</a></span> を使用して特定のフラグが存在するかどうかをチェックします。<span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"MArgParser.flagArgumentInt()\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_arg_parser.html#acef3d350f63e2a31b1481050f6bed971&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MArgParser.flagArgumentInt()</a></span> を呼び出すと、特定のフラグに整数として関連付けられている値が抽出されます。 \n\
            </p> \n\
            <div class=\"codeBlock\"><pre class=\"prettyprint\">    def doIt(self, args):\n\
        \'\'\' Command execution. \'\'\'\n\
        \n\
        # We recommend parsing your arguments first.\n\
        self.parseArguments( args )\n\
\n\
        # Remove the following \'pass\' keyword and replace it with the code you want to run. \n\
        pass\n\
    \n\
    def parseArguments(self, args):\n\
        \'\'\' \n\
        The presence of this function is not enforced,\n\
        but helps separate argument parsing code from other\n\
        command code. \n\
        \'\'\'\n\
        \n\
        # The following <a href=\"javascript:void(0)\" data-symbol=\"MArgParser\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_arg_parser.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_arg_parser.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MArgParser</a> object allows you to check if specific flags are set.\n\
        argData = <a href=\"javascript:void(0)\" data-symbol=\"OpenMaya.MArgParser\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_arg_parser.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">OpenMaya.MArgParser</a>( self.syntax(), args )\n\
        \n\
        if argData.isFlagSet( kShortFlagName ):\n\
                \n\
            # In this case, we print the passed flag\'s value as an integer.\n\
            # We use the \'0\' to index the flag\'s first and only parameter.\n\
            flagValue = argData.flagArgumentInt( kShortFlagName, 0 )\n\
            print kLongFlagName + \': \' + str( flagValue )\n\
            \n\
        \n\
        # ... If there are more flags, process them here ...</pre></div> \n\
            <p><a name=\"GUID-3CFAFB25-45D9-4252-BF2C-C34C8229976E\"></a> \n\
               <div><a name=\"GUID-8756CC25-5F10-4EAE-B16D-867764838542\"></a><div class=\"note-note\"><span class=\"label label-target-language\">注:</span>コマンド引数を解析するには、<span class=\"code\" translate=\"no\">MArgParser.commandArgument*()</span> 関数を使用します。<em class=\"mild\"></em>詳細については、<span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"MArgParser\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_arg_parser.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_arg_parser.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MArgParser</a></span> クラスのマニュアルを参照してください。 \n\
                  </div>\n\
               </div> \n\
            </p> \n\
         </div>\n\
         <div class=\"section\"><a name=\"SECTION_2C3E671A8E204226900E11E4FC8B2482\"></a> \n\
            <h2><a name=\"GUID-B5263FF6-9F2A-493E-9299-34E697568FE9\"></a>複数のパラメータを使用してフラグを解析する\n\
            </h2> \n\
            <p><a name=\"GUID-343FC1D6-115D-4C9F-A4FA-EC682D184626\"></a>次の使用事例のように、複数のパラメータ(たとえば、3 次元ベクトル)が含まれているフラグを解析する必要があると仮定します。<em class=\"mild\"></em> \n\
            </p> \n\
            <div class=\"codeBlock\"><pre class=\"prettyprint\">import maya.cmds as cmds\n\
cmds.loadPlugin( \'sampleCommandFlagTuple.py\' )\n\
cmds.myCommandWithTupleFlag( myTupleFlag = (10, 20, 30) )</pre></div> \n\
            <p><a name=\"GUID-81E495DE-ADF9-4F18-9B2A-ABA6376DE22D\"></a>これを実現するには、コードの 2 つのセクションを修正する必要があります。 \n\
            </p> <a name=\"OL_855F4B78DA29405FA7D40CC854127F0D\"></a><ol type=\"1\" start=\"1\">\n\
               <li><em class=\"strong\">構文作成関数</em>: 構文作成関数では、<span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"MSyntax.addFlag()\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_syntax.html#a71360d659ff4cb19f3f1bdc1d577a422&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MSyntax.addFlag()</a></span>への呼び出しに 3 つの <span class=\"code\" translate=\"no\">OpenMaya.MSyntax.kDouble</span> パラメータのタプルが必要です。この新しいフラグ構文定義により、このフラグの単一の数値ではなく、3 つの数値のタプルが Maya で認識されます。 \n\
                  <div class=\"codeBlock\"><pre class=\"prettyprint\">def syntaxCreator():\n\
    \'\'\' Defines the argument and flag syntax for this command. \'\'\'\n\
    syntax = <a href=\"javascript:void(0)\" data-symbol=\"OpenMaya.MSyntax\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_syntax.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">OpenMaya.MSyntax</a>()\n\
    \n\
    # In this example, our flag will be expecting three <a href=\"javascript:void(0)\" data-symbol=\"OpenMaya.MSyntax.kDouble\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_syntax.html#a9b557d97e6ea6e2e7a3757b810a4c627&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">OpenMaya.MSyntax.kDouble</a> parameters. \n\
    syntax.addFlag( kShortFlagName, kLongFlagName, (<a href=\"javascript:void(0)\" data-symbol=\"OpenMaya.MSyntax.kDouble\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_syntax.html#a9b557d97e6ea6e2e7a3757b810a4c627&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">OpenMaya.MSyntax.kDouble</a>, <a href=\"javascript:void(0)\" data-symbol=\"OpenMaya.MSyntax.kDouble\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_syntax.html#a9b557d97e6ea6e2e7a3757b810a4c627&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">OpenMaya.MSyntax.kDouble</a>, <a href=\"javascript:void(0)\" data-symbol=\"OpenMaya.MSyntax.kDouble\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_syntax.html#a9b557d97e6ea6e2e7a3757b810a4c627&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">OpenMaya.MSyntax.kDouble</a>) )\n\
    \n\
    # ... Add more flags here ...\n\
        \n\
    return syntax</pre></div> \n\
               </li>\n\
            </ol>\n\
            <div><a name=\"GUID-3FB9EB6F-3974-41B7-864D-029F60AEEE6E\"></a><div class=\"note-note\"><span class=\"label label-target-language\">注:</span>Python API 1.0 では、パラメータはタプル形式で渡されません。 \n\
               </div>\n\
            </div>\n\
            <ol type=\"1\" start=\"2\">\n\
               <li><em class=\"strong\">引数の解析</em>: <span class=\"code\" translate=\"no\">parseArguments()</span> のメソッド本体で、<span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"MArgParser.flagArgumentInt()\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_arg_parser.html#acef3d350f63e2a31b1481050f6bed971&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MArgParser.flagArgumentInt()</a></span> への 3 つの個別の呼び出しに対してインデックス <span class=\"code\" translate=\"no\">0</span>～<span class=\"code\" translate=\"no\">2</span> を使用して、フラグの 3 つのパラメータを解析します。 \n\
                  <div class=\"codeBlock\"><pre class=\"prettyprint\">    def doIt(self, args):\n\
        \'\'\' Command execution. \'\'\'\n\
        \n\
        # We recommend parsing your arguments first.\n\
        self.parseArguments( args )\n\
\n\
        # Remove the following \'pass\' keyword and replace it with the code you want to run. \n\
        pass\n\
    \n\
    def parseArguments(self, args):\n\
        \'\'\' \n\
        The presence of this function is not enforced,\n\
        but helps separate argument parsing code from other\n\
        command code. \n\
        \'\'\'\n\
        \n\
        # The following <a href=\"javascript:void(0)\" data-symbol=\"MArgParser\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_arg_parser.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_arg_parser.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MArgParser</a> object allows you to check if specific flags are set.\n\
        argData = <a href=\"javascript:void(0)\" data-symbol=\"OpenMaya.MArgParser\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_arg_parser.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">OpenMaya.MArgParser</a>( self.syntax(), args )\n\
        \n\
        if argData.isFlagSet( kShortFlagName ):\n\
                \n\
            # In this case, we print the passed flags\'s three parameters, indexed from 0 to 2.\n\
            flagParam0 = argData.flagArgumentInt( kShortFlagName, 0 )\n\
            flagParam1 = argData.flagArgumentInt( kShortFlagName, 1 )\n\
            flagParam2 = argData.flagArgumentInt( kShortFlagName, 2 )\n\
            \n\
            print kLongFlagName + \'[0]: \' + str( flagParam0 )\n\
            print kLongFlagName + \'[1]: \' + str( flagParam1 )\n\
            print kLongFlagName + \'[2]: \' + str( flagParam2 )</pre></div> \n\
               </li>\n\
            </ol> \n\
         </div>\n\
         <div class=\"section\"><a name=\"SECTION_622DEA046BF44005B6A15D805F1DBB44\"></a> \n\
            <h2><a name=\"GUID-7E422871-D0B6-4AF3-995E-68F090F8335E\"></a>サンプル コマンド プラグイン: 複数のパラメータを持つ 1 つのフラグ \n\
            </h2> \n\
            <p><a name=\"GUID-38A4CF8C-1721-4B63-A2C6-5B28359C13DC\"></a>次の Python コードは、指定したフラグで渡される 3 つのパラメータを出力するコマンドを作成します。 \n\
            </p> <a name=\"SECTION_4134AA2CB32E4C6AB3A6C4DC1F5315F9\"></a><details class=\"section\">\n\
               <summary><a name=\"GUID-6F128CB5-BC72-4BED-AB51-4F255436126F\"></a><span class=\"collapsible-section-title\">Python API 2.0: </span></summary>\n\
               <div class=\"collapsible-section\">\n\
                  <div class=\"codeBlock\"><pre class=\"prettyprint\"># pySampleCommandFlagTuple.py\n\
\n\
import sys\n\
import maya.api.OpenMaya as OpenMaya\n\
# ... additional imports here ...\n\
\n\
kPluginCmdName = \'myCommandWithTupleFlag\'\n\
\n\
kShortFlagName = \'-tf\'\n\
kLongFlagName = \'-myTupleFlag\'\n\
\n\
def maya_useNewAPI():\n\
	\"\"\"\n\
	The presence of this function tells Maya that the plugin produces, and\n\
	expects to be passed, objects created using the Maya Python API 2.0.\n\
	\"\"\"\n\
	pass\n\
	\n\
##########################################################\n\
# Plug-in \n\
##########################################################\n\
class MyCommandWithFlagTupleClass( <a href=\"javascript:void(0)\" data-symbol=\"OpenMaya.MPxCommand\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_px_command.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">OpenMaya.MPxCommand</a> ):\n\
    \n\
    def __init__(self):\n\
        \'\'\' Constructor. \'\'\'\n\
        <a href=\"javascript:void(0)\" data-symbol=\"OpenMaya.MPxCommand.__init__\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_px_command.html#a0e33c57b86f794759092176b16cc0b44&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">OpenMaya.MPxCommand.__init__</a>(self)\n\
    \n\
    def doIt(self, args):\n\
        \'\'\' Command execution. \'\'\'\n\
        \n\
        # We recommend parsing your arguments first.\n\
        self.parseArguments( args )\n\
\n\
        # Remove the following \'pass\' keyword and replace it with the code you want to run. \n\
        pass\n\
    \n\
    def parseArguments(self, args):\n\
        \'\'\' \n\
        The presence of this function is not enforced,\n\
        but helps separate argument parsing code from other\n\
        command code. \n\
        \'\'\'\n\
        \n\
        # The following <a href=\"javascript:void(0)\" data-symbol=\"MArgParser\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_arg_parser.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_arg_parser.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MArgParser</a> object allows you to check if specific flags are set.\n\
        argData = <a href=\"javascript:void(0)\" data-symbol=\"OpenMaya.MArgParser\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_arg_parser.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">OpenMaya.MArgParser</a>( self.syntax(), args )\n\
        \n\
        if argData.isFlagSet( kShortFlagName ):\n\
                \n\
            # In this case, we print the passed flags\'s three parameters, indexed from 0 to 2.\n\
            flagParam0 = argData.flagArgumentInt( kShortFlagName, 0 )\n\
            flagParam1 = argData.flagArgumentInt( kShortFlagName, 1 )\n\
            flagParam2 = argData.flagArgumentInt( kShortFlagName, 2 )\n\
            \n\
            print kLongFlagName + \'[0]: \' + str( flagParam0 )\n\
            print kLongFlagName + \'[1]: \' + str( flagParam1 )\n\
            print kLongFlagName + \'[2]: \' + str( flagParam2 )\n\
            \n\
        \n\
        # ... If there are more flags, process them here ...\n\
\n\
##########################################################\n\
# Plug-in initialization.\n\
##########################################################\n\
def cmdCreator():\n\
    \'\'\' Create an instance of our command. \'\'\'\n\
    return MyCommandWithFlagTupleClass()\n\
\n\
def syntaxCreator():\n\
    \'\'\' Defines the argument and flag syntax for this command. \'\'\'\n\
    syntax = <a href=\"javascript:void(0)\" data-symbol=\"OpenMaya.MSyntax\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_syntax.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">OpenMaya.MSyntax</a>()\n\
    \n\
    # In this example, our flag will be expecting three <a href=\"javascript:void(0)\" data-symbol=\"OpenMaya.MSyntax.kDouble\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_syntax.html#a9b557d97e6ea6e2e7a3757b810a4c627&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">OpenMaya.MSyntax.kDouble</a> parameters. \n\
    syntax.addFlag( kShortFlagName, kLongFlagName, (<a href=\"javascript:void(0)\" data-symbol=\"OpenMaya.MSyntax.kDouble\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_syntax.html#a9b557d97e6ea6e2e7a3757b810a4c627&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">OpenMaya.MSyntax.kDouble</a>, <a href=\"javascript:void(0)\" data-symbol=\"OpenMaya.MSyntax.kDouble\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_syntax.html#a9b557d97e6ea6e2e7a3757b810a4c627&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">OpenMaya.MSyntax.kDouble</a>, <a href=\"javascript:void(0)\" data-symbol=\"OpenMaya.MSyntax.kDouble\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_syntax.html#a9b557d97e6ea6e2e7a3757b810a4c627&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">OpenMaya.MSyntax.kDouble</a>) )\n\
    \n\
    # ... Add more flags here ...\n\
        \n\
    return syntax\n\
    \n\
def initializePlugin( mobject ):\n\
    \'\'\' Initialize the plug-in when Maya loads it. \'\'\'\n\
    mplugin = <a href=\"javascript:void(0)\" data-symbol=\"OpenMaya.MFnPlugin\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_fn_plugin.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">OpenMaya.MFnPlugin</a>( mobject )\n\
    try:\n\
        mplugin.registerCommand( kPluginCmdName, cmdCreator, syntaxCreator )\n\
    except:\n\
        sys.stderr.write( \'Failed to register command: \' + kPluginCmdName )\n\
\n\
def uninitializePlugin( mobject ):\n\
    \'\'\' Uninitialize the plug-in when Maya un-loads it. \'\'\'\n\
    mplugin = <a href=\"javascript:void(0)\" data-symbol=\"OpenMaya.MFnPlugin\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_fn_plugin.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">OpenMaya.MFnPlugin</a>( mobject )\n\
    try:\n\
        mplugin.deregisterCommand( kPluginCmdName )\n\
    except:\n\
        sys.stderr.write( \'Failed to unregister command: \' + kPluginCmdName )\n\
\n\
##########################################################\n\
# Sample usage.\n\
##########################################################\n\
\'\'\' \n\
# Copy the following lines and run them in Maya\'s Python Script Editor:\n\
\n\
import maya.cmds as cmds\n\
cmds.loadPlugin( \'sampleCommandFlagTuple.py\' )\n\
cmds.myCommandWithTupleFlag( myTupleFlag = (10, 20, 30) )\n\
\n\
\'\'\'</pre></div>\n\
               </div>\n\
            </details> <a name=\"SECTION_161C800069024B1484ACAAE58B321763\"></a><details class=\"section\">\n\
               <summary><a name=\"GUID-7D620E11-7F60-4AEE-B453-309F718E86CD\"></a><span class=\"collapsible-section-title\">Python API 1.0: </span></summary>\n\
               <div class=\"collapsible-section\">\n\
                  <div class=\"codeBlock\"><pre class=\"prettyprint\"># sampleCommandFlagTuple.py\n\
\n\
import sys\n\
import maya.OpenMayaMPx as OpenMayaMPx\n\
import maya.OpenMaya as OpenMaya\n\
# ... additional imports here ...\n\
\n\
kPluginCmdName = \'myCommandWithTupleFlag\'\n\
\n\
kShortFlagName = \'-tf\'\n\
kLongFlagName = \'-myTupleFlag\'\n\
\n\
##########################################################\n\
# Plug-in \n\
##########################################################\n\
class MyCommandWithFlagTupleClass( OpenMayaMPx.MPxCommand ):\n\
    \n\
    def __init__(self):\n\
        \'\'\' Constructor. \'\'\'\n\
        OpenMayaMPx.MPxCommand.__init__(self)\n\
    \n\
    def doIt(self, args):\n\
        \'\'\' Command execution. \'\'\'\n\
        \n\
        # We recommend parsing your arguments first.\n\
        self.parseArguments( args )\n\
\n\
        # Remove the following \'pass\' keyword and replace it with the code you want to run. \n\
        pass\n\
    \n\
    def parseArguments(self, args):\n\
        \'\'\' \n\
        The presence of this function is not enforced,\n\
        but helps separate argument parsing code from other\n\
        command code. \n\
        \'\'\'\n\
        \n\
        # The following <a href=\"javascript:void(0)\" data-symbol=\"MArgParser\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_arg_parser.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_arg_parser.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MArgParser</a> object allows you to check if specific flags are set.\n\
        argData = <a href=\"javascript:void(0)\" data-symbol=\"OpenMaya.MArgParser\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_arg_parser.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">OpenMaya.MArgParser</a>( self.syntax(), args )\n\
        \n\
        if argData.isFlagSet( kShortFlagName ):\n\
                \n\
            # In this case, we print the passed flags\'s three parameters, indexed from 0 to 2.\n\
            flagParam0 = argData.flagArgumentInt( kShortFlagName, 0 )\n\
            flagParam1 = argData.flagArgumentInt( kShortFlagName, 1 )\n\
            flagParam2 = argData.flagArgumentInt( kShortFlagName, 2 )\n\
            \n\
            print kLongFlagName + \'[0]: \' + str( flagParam0 )\n\
            print kLongFlagName + \'[1]: \' + str( flagParam1 )\n\
            print kLongFlagName + \'[2]: \' + str( flagParam2 )\n\
            \n\
        \n\
        # ... If there are more flags, process them here ...\n\
\n\
##########################################################\n\
# Plug-in initialization.\n\
##########################################################\n\
def cmdCreator():\n\
    \'\'\' Create an instance of our command. \'\'\'\n\
    return OpenMayaMPx.asMPxPtr( MyCommandWithFlagTupleClass() )\n\
\n\
def syntaxCreator():\n\
    \'\'\' Defines the argument and flag syntax for this command. \'\'\'\n\
    syntax = <a href=\"javascript:void(0)\" data-symbol=\"OpenMaya.MSyntax\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_syntax.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">OpenMaya.MSyntax</a>()\n\
    \n\
    # In this example, our flag will be expecting three <a href=\"javascript:void(0)\" data-symbol=\"OpenMaya.MSyntax.kDouble\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_syntax.html#a9b557d97e6ea6e2e7a3757b810a4c627&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">OpenMaya.MSyntax.kDouble</a> parameters. \n\
    syntax.addFlag( kShortFlagName, kLongFlagName, <a href=\"javascript:void(0)\" data-symbol=\"OpenMaya.MSyntax.kDouble\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_syntax.html#a9b557d97e6ea6e2e7a3757b810a4c627&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">OpenMaya.MSyntax.kDouble</a>, <a href=\"javascript:void(0)\" data-symbol=\"OpenMaya.MSyntax.kDouble\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_syntax.html#a9b557d97e6ea6e2e7a3757b810a4c627&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">OpenMaya.MSyntax.kDouble</a>, <a href=\"javascript:void(0)\" data-symbol=\"OpenMaya.MSyntax.kDouble\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_syntax.html#a9b557d97e6ea6e2e7a3757b810a4c627&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">OpenMaya.MSyntax.kDouble</a> )\n\
    \n\
    # ... Add more flags here ...\n\
        \n\
    return syntax\n\
    \n\
def initializePlugin( mobject ):\n\
    \'\'\' Initialize the plug-in when Maya loads it. \'\'\'\n\
    mplugin = OpenMayaMPx.MFnPlugin( mobject )\n\
    try:\n\
        mplugin.registerCommand( kPluginCmdName, cmdCreator, syntaxCreator )\n\
    except:\n\
        sys.stderr.write( \'Failed to register command: \' + kPluginCmdName )\n\
\n\
def uninitializePlugin( mobject ):\n\
    \'\'\' Uninitialize the plug-in when Maya un-loads it. \'\'\'\n\
    mplugin = OpenMayaMPx.MFnPlugin( mobject )\n\
    try:\n\
        mplugin.deregisterCommand( kPluginCmdName )\n\
    except:\n\
        sys.stderr.write( \'Failed to unregister command: \' + kPluginCmdName )\n\
\n\
##########################################################\n\
# Sample usage.\n\
##########################################################\n\
\'\'\' \n\
# Copy the following lines and run them in Maya\'s Python Script Editor:\n\
\n\
import maya.cmds as cmds\n\
cmds.loadPlugin( \'sampleCommandFlagTuple.py\' )\n\
cmds.myCommandWithTupleFlag( myTupleFlag = (10, 20, 30) )\n\
\n\
\'\'\'</pre></div>\n\
               </div>\n\
            </details> \n\
         </div>\n\
         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">このトピックについてのコメントをお送りください</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/deed.ja\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"images/ccLink.png\"></a>&nbsp;<em>特に明記されている場合以外は、この作業は、<a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/deed.ja\" target=\"_blank\">Creative Commons 表示 - 非営利 - 継承 3.0 非移植ライセンス</a> のもと認可を受けています。 <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> (英語版) を参照してください。</em></p><br></div>\n\
   </div></body>\n\
</html>";