var topic = "<!DOCTYPE html>\n\
\n\
<!-- saved from url=(0024)http://docs.autodesk.com -->\n\
<html>\n\
   <head>\n\
<link href=\"../style/prettify.css\" type=\"text/css\" rel=\"stylesheet\">\n\
<script type=\"text/javascript\" src=\"../scripts/prettify.js\"></script><script src=\"../scripts/lib/jquery-1.11.1.min.js\" type=\"text/javascript\"></script>\n\
      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n\
      <meta name=\"product\" content=\"MAYAUL\">\n\
      <meta name=\"release\" content=\"2018\">\n\
      <meta name=\"book\" content=\"Developer\">\n\
      <meta name=\"created\" content=\"2017-02-19\">\n\
      <meta name=\"topicid\" content=\"GUID-F96282D5-4F05-40A6-8FB9-875E1427D0A4\">\n\
      <meta name=\"topic-type\" content=\"concept\">\n\
      <title>カスタム トランスフォームを実装する</title></head>\n\
   <body height=\"100%\"><div class=\"body_content\" id=\"body-content\"><script language=\"javascript\">var index = \'index.html\';</script><script>$(document).ready(function() { yepnope.injectJs(\"./scripts/ac_common.js\"); });</script><script>$(document).ready(function() { yepnope.injectJs(\"./scripts/multireflink.js\"); });</script><script>$(document).ready(function () { prettyPrint(); } );</script><script></script><script></script><div id=\"reflinkdiv\"></div>\n\
      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-F96282D5-4F05-40A6-8FB9-875E1427D0A4\"></a><div class=\"head\">\n\
            <h1>カスタム トランスフォームを実装する</h1>\n\
         </div>\n\
         <p><a name=\"WS73099CC142F48755-3D114B7511841AEFA9FAA3\"></a>カスタム トランスフォームを実装する場合、トランスフォームの構築やアトリビュートの設定などを行う必要があります。\n\
         </p>\n\
         <div class=\"section\"><a name=\"WS73099CC142F48755-3D114B7511841AEFA9FAA4\"></a> \n\
            <h2><a name=\"GUID-193B92EC-3749-4AF1-A996-CFF9BBFD688A\"></a>単純なカスタム トランスフォームと複雑なカスタム トランスフォーム\n\
            </h2> \n\
            <p><a name=\"WS73099CC142F48755-3D114B7511841AEFA9FAA5\"></a>トランスフォームには、トランスフォーム情報の処理と格納に使用される入力と出力アトリビュートがあります。最も単純なカスタム トランスフォームは、変換行列に影響を与える可能性のある新規アトリビュートを一切導入しないトランスフォームです。たとえば、この種のトランスフォームは、事前に決められた計算を利用して、<span class=\"code\" translate=\"no\">移動(Translate)</span>アトリビュートを一定のワールド空間領域に制限します。 \n\
            </p> \n\
            <p><a name=\"WS73099CC142F48755-3D114B7511841AEFA9FAA6\"></a>複雑なカスタム トランスフォームは、変換行列に影響を与える 1 つまたは複数のアトリビュートを導入するトランスフォームです。たとえば、この種のトランスフォームは、変換行列の最終的な計算で使用される新しいタイプの回転パラメータを導入することができます。この場合、カスタム\n\
               トランスフォームは 2 種類の回転を認識するため、新しい回転を計算する際にオリジナルの回転アトリビュート(<span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"MPxTransform\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_px_transform.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MPxTransform</a></span> によって提供される)が影響を受けることはありません。\n\
            </p> \n\
         </div>\n\
         <div class=\"section\"><a name=\"WS73099CC142F48755-3D114B7511841AEFA9FAA7\"></a> \n\
            <h2><a name=\"GUID-93F647CC-CF71-49D6-8E2C-DCFB3FA55686\"></a>ワールド空間(World space)アトリビュート\n\
            </h2> \n\
            <p><a name=\"WS73099CC142F48755-3D114B7511841AEFA9FAA8\"></a>オブジェクトをインスタンス化するとシステム メモリが節約され、正確なプロパティを維持しながら 1 つのオブジェクトを複数回表示するのに便利です。ただし、同一のオブジェクトに対する複数のパスが存在するため、オブジェクトをインスタンス化すると、コーディング上の問題が表れます。Maya\n\
               はワールド空間に分類される配列アトリビュートを使用してこの状況に対処します。複数のパスを処理するには、配列が必要です。\n\
            </p> \n\
            <p><a name=\"WS73099CC142F48755-3D114B7511841AEFA9FAA9\"></a>ワールド空間アトリビュートは、独自の座標変換に加えてオブジェクトの親の座標変換に依存しています。アトリビュートをワールド空間としてマーキングすると、親のいずれかが変換された場合にアトリビュートが再計算されます(要求時)。ワールド空間アトリビュートは、上記の例のインスタンス化を処理する配列です。<span class=\"code\" translate=\"no\">worldMatrix</span> はワールド空間アトリビュートの一例です。アトリビュートを配列として設定し、ワールド空間としてマーキングする処理は、カスタム トランスフォーム ノードの <span class=\"code\" translate=\"no\">initialize()</span> メソッドで <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"MFnAttribute\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_fn_attribute.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_fn_attribute.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MFnAttribute</a></span> クラスを使用して実行されます。\n\
            </p> \n\
            <p><a name=\"WS73099CC142F48755-3D114B7511841AEFA9FAAA\"></a>ワールド空間アトリビュートが配列である場合には、<span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"MArrayDataBuilder\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_array_data_builder.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_array_data_builder.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MArrayDataBuilder</a></span> クラスを使用してアトリビュートに配置される情報を作成できます。その後、<span class=\"code\" translate=\"no\">initialize()</span> メソッドで <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"MFnAttribute::setUsesArrayDataBuilder()\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_fn_attribute.html#a08fb5fd3764795485a0d799616646ef1&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MFnAttribute::setUsesArrayDataBuilder()</a></span> を使用してアトリビュートを設定する必要があります。\n\
            </p> \n\
         </div>\n\
         <div class=\"section\"><a name=\"WS73099CC142F48755-3D114B7511841AEFA9FAAB\"></a> \n\
            <h2><a name=\"GUID-70CC77C2-1AF6-4002-B8E7-1C057406FC34\"></a>ワールド空間に作用(Affects world space)アトリビュート\n\
            </h2> \n\
            <p><a name=\"WS73099CC142F48755-3D114B7511841AEFA9FAAC\"></a><em class=\"mild\"></em>ワールド空間に作用(Affects world space)としてマーキングされたアトリビュートは、特定のノードとそのノードの子 DAG でワールド空間アトリビュートを再計算させます(ワールド空間が要求される場合)。このタイプのアトリビュートに対する配列の要件はありません。DAG\n\
               ノードにある<span class=\"code\" translate=\"no\">移動(Translate)</span>アトリビュートはワールド空間に作用アトリビュートの一例です。カスタム トランスフォームノードの <span class=\"code\" translate=\"no\">initialize()</span> メソッドで <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"MFnAttribute\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_fn_attribute.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_fn_attribute.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MFnAttribute</a></span> クラスを使用して実行されます。\n\
            </p> \n\
         </div>\n\
         <div class=\"section\"><a name=\"WS73099CC142F48755-3D114B7511841AEFA9FAAD\"></a> \n\
            <h2><a name=\"GUID-5146E2A8-F3BF-4639-B0E4-12A391BB7794\"></a>トランスフォームの制限\n\
            </h2> \n\
            <p><a name=\"WS73099CC142F48755-3D114B7511841AEFA9FAAE\"></a>トランスフォーム ノード(およびカスタム トランスフォームノード)には特別なアトリビュートが存在します。このアトリビュートは関連するアトリビュートの値をクランプする場合に使用します。トランスフォームの制限は\n\
               <span class=\"code\" translate=\"no\">移動</span>、<span class=\"code\" translate=\"no\">回転</span>、<span class=\"code\" translate=\"no\">スケール</span>で使用できます。それぞれの操作には、有効(Enabled)、最小(Minimum)、最大(Maximum)の 3 つのアトリビュートが含まれます。これらのアトリビュートを変更するカスタム\n\
               トランスフォームを使用すると、<span class=\"code\" translate=\"no\">移動</span>、<span class=\"code\" translate=\"no\">回転</span>、<span class=\"code\" translate=\"no\">スケール</span>をワールド空間の一部に制限するノードを実現できます。これは、カスタム トランスフォームの単純な実施例です。複雑なカスタム トランスフォームを使用すると、別のオブジェクトまでの距離などの外部アトリビュート入力に基づいて最小値と最大値を変更できます。\n\
               \n\
            </p> \n\
         </div>\n\
         <div class=\"section\"><a name=\"WS73099CC142F48755-3D114B7511841AEFA9FAAF\"></a> \n\
            <h2><a name=\"GUID-E77748BC-2B2D-482E-B715-00CE872CD254\"></a>トランスフォームのバランシング\n\
            </h2> \n\
            <p><a name=\"WS73099CC142F48755-3D114B7511841AEFA9FAB0\"></a>Maya のトランスフォーム ノードでは、ピボット(回転とスケール)や回転順序を変更しても変換行列を同じ状態に維持できます。これは、<em class=\"mild\"></em>トランスフォームのバランシングと呼ばれます。バランシングは、ピボットや回転順序情報の変更に関連するメソッドに含まれるパラメータです。<span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"MPxTransform\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_px_transform.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MPxTransform</a></span> と <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"MPxTransformationMatrix\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_px_transformation_matrix.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MPxTransformationMatrix</a></span> の仮想メソッドは、カスタム トランスフォームが Maya の標準的なピボットの処理方法を変更しようとしない限り、バランシングを正しく処理します。\n\
            </p> \n\
         </div>\n\
         <div class=\"section\"><a name=\"WS73099CC142F48755-3D114B7511841AEFA9FAB1\"></a> \n\
            <h2><a name=\"GUID-DEB43F25-DFE1-42B7-926A-075C3A7E7CBB\"></a>検証および設定\n\
            </h2> \n\
            <p><a name=\"WS73099CC142F48755-3D114B7511841AEFA9FAB2\"></a>Maya は標準的な<em class=\"mild\"></em>検証と設定の仕組みを使ってカスタム トランスフォームのアトリビュート値を更新します。行列に影響を与えるアトリビュートの場合、必ずこの仕組みを使用する必要があります。トランスフォームの行列に影響を与えるアトリビュートの場合、必ず\n\
               <span class=\"code\" translate=\"no\">initialize()</span> メソッドで <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"MPxTransform::mustCallValidateAndSet()\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_px_transform.html#a0533b06e6c41eed320612ce1aae241f9&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MPxTransform::mustCallValidateAndSet()</a></span> をコールする必要があります。このようにすると、アトリビュートの変更時に行列が正しく計算され、このアトリビュートに対して <span class=\"code\" translate=\"no\">MPxTransform::validateAndSet()</span> メソッドがコールされます。 \n\
            </p> \n\
         </div>\n\
         <div class=\"section\"><a name=\"WS73099CC142F48755-3D114B7511841AEFA9FAB3\"></a> \n\
            <h2><a name=\"GUID-283CFD80-365B-4157-8FAC-4E9F30F44AA1\"></a>行列を返す方法\n\
            </h2> \n\
            <p><a name=\"WS73099CC142F48755-3D114B7511841AEFA9FAB4\"></a>Maya は DG 更新処理の一環として、カスタム トランスフォームに変換行列を要求します。この要求は <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"MPxTransform::getMatrix()\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_px_transform.html#a2071cf7ee9a21915a5a9c139b2b212a2&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MPxTransform::getMatrix()</a></span> コールに直接渡されます。次に、この仮想メソッドは、<span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"MPxTransformationMatrix::asMatrix()\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_px_transformation_matrix.html#a8e2933c5f73e8cfb7409366582caa596&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MPxTransformationMatrix::asMatrix()</a></span> をコールします。カスタム トランスフォームが Maya に行列を返すようにするには、これらの 2 つのメソッドを実装する必要があります。\n\
            </p> \n\
         </div>\n\
         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">このトピックについてのコメントをお送りください</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/deed.ja\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"images/ccLink.png\"></a>&nbsp;<em>特に明記されている場合以外は、この作業は、<a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/deed.ja\" target=\"_blank\">Creative Commons 表示 - 非営利 - 継承 3.0 非移植ライセンス</a> のもと認可を受けています。 <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> (英語版) を参照してください。</em></p><br></div>\n\
   </div></body>\n\
</html>";